%  function  calcint.m %---------------------------------------------
% функция расчета определенного интеграла методом трапеций
% шаги  - ввод данных и форматирование, проверка на ошибки, 
% вычисление значения  определенного интеграла, вывод в консоль,
% вывод графика, вызов подменю для ввода толщины и цвета линии  на графике
function calcint() 
% ввод данных и форматирование
% создание диалогового окна для ввода от пользователя
% таблично заданной функции, пределов и  шага интегрирования
ansstr = '';
prompt = {'Введите аргументы х через пробел',... 
    'Введите значения функции y через пробел',... 
    'Нижний предел интегрирования xmin',...
    'Верхний предел интегрирования xmax'};
dlg_title = 'Ввод данных';
num_lines = 1;
% загрузка последних введённых данных
try
load 'ansstr.mat'
catch
    strx = '0 0.1000 0.2000 0.3000 0.4000 0.5000 0.6000 0.7000 0.8000 0.9000 1.0000';
    stry = '1.0000 1.1107 1.2462 1.4130 1.6197 1.8787 2.2077 2.6329 3.1944  3.9568 5.0310';
    ansstr = {strx,stry,'0.2','0.9'};
end

defaultans = ansstr;

ansstr = inputdlg(prompt,dlg_title,num_lines,defaultans,'on');% открытие окна
% если пользователь нажал Cancel - выход  из функции
if isempty(ansstr) == 1  
    return;
end
% сохранение последних введённых данных
save 'ansstr.mat'
try
% форматирование строкового типа в числовой

x = double(cell2mat(textscan(ansstr{1},'%f'))'); % аргумент
y = cell2mat(textscan(ansstr{2},'%f'))';% значение функции
xmin = str2double(ansstr{3}); % верхний предел интегрирования
xmax = str2double(ansstr{4}); % нижний предел интегрирования

% проверка на ошибки -------------------------------------------
assert(~(length(x)~= length(y)),'length x != y');
assert(isvector(x), 'x not vector');
assert(isvector(y), 'y not vector');
assert(isreal(x),'x not real');
assert(isreal(y),'y not real');
assert(isreal(xmin),'Limit xmin, not real');
assert(isreal(xmax),'Limit xmax, not real');
assert(~isnan(xmin),'Limit xmin, not real');
assert(~isnan(xmax),'Limit xmax, not real');
[r,c,L1] = find(xmin == x);
[r,c,L2] = find(xmax == x);
assert(~isempty(L1),'Limit xmin no reside  x');
assert(~isempty(L2),'Limit xmax no reside  x');

% вычисление значения  определенного интеграла
% В X и Y массивах значения 
% усекаются до пределов интегрирования.
[r,c] = find(x >= xmin & x <= xmax);
X = x(c); Y = y(c);
Q = trapz(X, Y);

catch ERR % если ошибка 
    % вывод в консоль сообщения об ошибке 
    fprintf(1, '\n\n');
    display('Ошибка ввода:')
    display(ERR.message)
    % Подсказа для пользователя - продолжить ввод или выйти 
    s = 'Повторить ввод? Да(y)/Нет (Другой любой символ) + Enter';   
    fprintf('%s\n',s);
    s = input('Ваш выбор?:','s');% ввод от пользователя
    if (s ~= 'y') % выход из функции, если нажата клавиша у 
     fprintf(1, '\n');
        return; 
    end
   calcint;% продолжение ввода - рекурсия
   fprintf(1, '\n');fprintf(1, '\n');
   return;
end

% вывод в консоль  раситанного интеграла Q
% и ределов  интегрирования
fprintf(1, '\n');
fprintf('%s\n', 'Результаты вычислений');
fprintf('нижний предел интегрирования %.4f\n',xmin);
fprintf('верхний предел интегрирования %.4f\n',xmax);
fprintf('Значение определенного интеграла: %.4f\n',Q);
fprintf(1, '\n');

% создание и открытия диалогового окна с запросом изменения
% цвет и толщины линии графика
choice = questdlg('Вы будете изменять толщину и цвет линии графика?', ...
    'Информация', ...
    'Да','По умолчанию','По умолчанию');

% вывода графика
% вызов функции для вывода графика подынтегральной функции и пределов 
%интегрирования 
h = plotint(x,y, xmin, xmax);
s = strcat('Значение интеграла = ',num2str(Q));
title(h,s); 

% вход в подменю submenu или возвращение в главное меню
switch choice
    case 'Да' % выбор редактирования линии
        submenu(h); % вызов функции  submenu(h) для редактирования линии
    case 'По умолчанию';return; % цвет и толщина умолчанию
end
 
end 

%   end function  calcint.m % -----------------------------------------